3021: Cache packages with bundle package --all
[arvados-dev.git] / jenkins / run-tests.sh
index 93d1c2b1c585a626243201302ff5dd60089cb7ed..98734ca62dd72f6d2a812bd88af204c5b849104f 100755 (executable)
@@ -47,7 +47,8 @@ https://arvados.org/projects/arvados/wiki/Running_tests
 Available tests:
 
 apps/workbench
-apps/workbench_performance
+apps/workbench_benchmark
+apps/workbench_profile
 doc
 services/api
 services/crunchstat
@@ -167,9 +168,19 @@ sanity_checks() {
 
 }
 
+rotate_logfile() {
+  # $BUILD_NUMBER is set by Jenkins if this script is being called as part of a Jenkins run
+  if [[ -f "$1/$2" ]]; then
+    THEDATE=`date +%Y%m%d%H%M%S`
+    mv "$1/$2" "$1/$THEDATE-$BUILD_NUMBER-$2"
+    gzip "$1/$THEDATE-$BUILD_NUMBER-$2"
+  fi
+}
+
 declare -a failures
 declare -A skip
 declare -A testargs
+skip[apps/workbench_profile]=1
 
 while [[ -n "$1" ]]
 do
@@ -185,7 +196,7 @@ do
             skip[$skipwhat]=1
             ;;
         --only)
-            only="$1"; shift
+            only="$1"; skip[$1]=""; shift
             ;;
         --skip-install)
             skip_install=1
@@ -323,7 +334,11 @@ then
 fi
 
 # Needed for run_test_server.py which is used by certain (non-Python) tests.
-pip install PyYAML
+pip install PyYAML || fatal "pip install PyYAML failed"
+
+# Needed for python-daemon 2.0.2, which breaks otherwise with
+# "ImportError: No module named docutils.core"
+pip install docutils || fatal "pip install docutils failed"
 
 checkexit() {
     if [[ "$?" != "0" ]]; then
@@ -352,16 +367,8 @@ do_test() {
             go test ${testargs[$1]} "git.curoverse.com/arvados.git/$1"
         elif [[ "$2" == "pip" ]]
         then
-           # Other test suites can depend on tests_require
-           # dependencies of this package. For example, keepproxy runs
-           # run_test_server.py, which depends on the yaml package,
-           # which is in sdk/python's tests_require but not
-           # install_requires, and therefore does not get installed by
-           # setuptools until we run "setup.py test" *and* install the
-           # .egg files that setup.py downloads.
            cd "$WORKSPACE/$1" \
-                && python setup.py test ${testargs[$1]} \
-                && (easy_install *.egg || true)
+                && python setup.py test ${testargs[$1]}
         elif [[ "$2" != "" ]]
         then
             "test_$2"
@@ -407,16 +414,20 @@ title () {
 }
 
 install_doc() {
-    cd "$WORKSPACE/doc"
-    bundle install --no-deployment
-    rm -rf .site
+    cd "$WORKSPACE/doc" \
+        && (bundle install --local --no-deployment \
+        || bundle install --no-deployment) \
+        && bundle package --all \
+        && rm -rf .site
 }
 do_install doc
 
 install_ruby_sdk() {
     with_test_gemset gem uninstall --force --all --executables arvados \
         && cd "$WORKSPACE/sdk/ruby" \
-        && bundle install --no-deployment \
+        && (bundle install --local --no-deployment \
+        || bundle install --no-deployment) \
+        && bundle package --all \
         && gem build arvados.gemspec \
         && with_test_gemset gem install --no-ri --no-rdoc `ls -t arvados-*.gem|head -n1`
 }
@@ -425,7 +436,9 @@ do_install sdk/ruby ruby_sdk
 install_cli() {
     with_test_gemset gem uninstall --force --all --executables arvados-cli \
         && cd "$WORKSPACE/sdk/cli" \
-        && bundle install --no-deployment \
+        && (bundle install --local --no-deployment \
+        || bundle install --no-deployment) \
+        && bundle package --all \
         && gem build arvados-cli.gemspec \
         && with_test_gemset gem install --no-ri --no-rdoc `ls -t arvados-cli-*.gem|head -n1`
 }
@@ -448,8 +461,10 @@ do
 done
 
 install_apiserver() {
-    cd "$WORKSPACE/services/api"
-    RAILS_ENV=test bundle install --no-deployment
+    cd "$WORKSPACE/services/api" \
+        && (RAILS_ENV=test bundle install --local --no-deployment \
+        || RAILS_ENV=test bundle install --no-deployment) \
+        && bundle package --all
 
     rm -f config/environments/test.rb
     cp config/environments/test.rb.example config/environments/test.rb
@@ -489,8 +504,8 @@ install_apiserver() {
 
     cd "$WORKSPACE/services/api" \
         && RAILS_ENV=test bundle exec rake db:drop \
-        && RAILS_ENV=test bundle exec rake db:create \
-        && RAILS_ENV=test bundle exec rake db:setup
+        && RAILS_ENV=test bundle exec rake db:setup \
+        && RAILS_ENV=test bundle exec rake db:fixtures:load
 }
 do_install services/api apiserver
 
@@ -510,42 +525,62 @@ done
 
 install_workbench() {
     cd "$WORKSPACE/apps/workbench" \
-        && RAILS_ENV=test bundle install --no-deployment
+        && (RAILS_ENV=test bundle install --local --no-deployment \
+        || RAILS_ENV=test bundle install --no-deployment) \
+        && bundle package --all
 }
 do_install apps/workbench workbench
 
+start_api() {
+    echo 'Starting API server...'
+    cd "$WORKSPACE" && \
+        eval $(python sdk/python/tests/run_test_server.py start --auth admin) && \
+        export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" && \
+        export ARVADOS_TEST_API_INSTALLED="$$" && \
+        (env | egrep ^ARVADOS)
+}
+
+stop_api() {
+    unset ARVADOS_TEST_API_HOST
+    cd "$WORKSPACE" && \
+        python sdk/python/tests/run_test_server.py stop
+}
+
 test_doclinkchecker() {
-    cd "$WORKSPACE/doc"
-    # Make sure python-epydoc is installed or the next line won't do much good!
-    ARVADOS_API_HOST=qr1hi.arvadosapi.com
-    PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
-    unset ARVADOS_API_HOST
+    (
+        set -e
+        cd "$WORKSPACE/doc"
+        ARVADOS_API_HOST=qr1hi.arvadosapi.com
+        # Make sure python-epydoc is installed or the next line won't
+        # do much good!
+        PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
+    )
 }
 do_test doc doclinkchecker
 
+stop_api
+
+test_apiserver() {
+    cd "$WORKSPACE/services/api"
+    RAILS_ENV=test bundle exec rake test ${testargs[services/api]}
+}
+do_test services/api apiserver
+
+start_api
+
 test_ruby_sdk() {
     cd "$WORKSPACE/sdk/ruby" \
-        && bundle install --no-deployment \
         && bundle exec rake test ${testargs[sdk/ruby]}
 }
 do_test sdk/ruby ruby_sdk
 
 test_cli() {
     cd "$WORKSPACE/sdk/cli" \
-        && bundle install --no-deployment \
         && mkdir -p /tmp/keep \
         && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test ${testargs[sdk/cli]}
 }
 do_test sdk/cli cli
 
-test_apiserver() {
-    cd "$WORKSPACE/services/api"
-    RAILS_ENV=test bundle exec rake test ${testargs[apiserver]}
-}
-do_test services/api apiserver
-
-# We must test sdk/python before testing services/keepproxy, because
-# keepproxy depends on sdk/python's test dependencies.
 for p in "${pythonstuff[@]}"
 do
     do_test "$p" pip
@@ -558,15 +593,26 @@ done
 
 test_workbench() {
     cd "$WORKSPACE/apps/workbench" \
-        && RAILS_ENV=test bundle exec rake test ${testargs[workbench]}
+        && RAILS_ENV=test bundle exec rake test ${testargs[apps/workbench]}
 }
 do_test apps/workbench workbench
 
-test_workbench_performance() {
+test_workbench_benchmark() {
     cd "$WORKSPACE/apps/workbench" \
-        && RAILS_ENV=test bundle exec rake test:benchmark
+        && RAILS_ENV=test bundle exec rake test:benchmark ${testargs[apps/workbench_benchmark]}
 }
-do_test apps/workbench_performance workbench_performance
+do_test apps/workbench_benchmark workbench_benchmark
+
+test_workbench_profile() {
+    cd "$WORKSPACE/apps/workbench" \
+        && RAILS_ENV=test bundle exec rake test:profile ${testargs[apps/workbench_profile]}
+}
+do_test apps/workbench_profile workbench_profile
+
+rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
+
+stop_api
+rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
 
 report_outcomes
 clear_temp